
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module PCIE_DDR3(

	//////////// CLOCK //////////
	OSC_50_BANK1,
	OSC_50_BANK3,
	OSC_50_BANK4,
	OSC_50_BANK7,
	OSC_50_BANK8,

	//////////// Loop //////////
	LOOP_CLKIN0,
	LOOP_CLKIN1,
	LOOP_CLKOUT0,
	LOOP_CLKOUT1,

	//////////// LED x 4 //////////
	LED,

	//////////// BUTTON x 4 //////////
	BUTTON,

	//////////// SWITCH x 4 //////////
	SW,

	//////////// Temperature //////////
	TEMP_INT_n,
	TEMP_OVERT_n,
	TEMP_SMCLK,
	TEMP_SMDAT,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// PCIe0 4-Lane Downstream //////////
	PCIE0_PERST_n,
	PCIE0_REFCLK_p,
	PCIE0_RX_p,
	PCIE0_TX_p,
	PCIE0_WAKE_n,

	//////////// Flash and SRAM Address/Data/OE/WM Share Bus //////////
	FSM_A,
	FSM_D,
	FSM_OE_n,
	FSM_WE_n,

	//////////// Flash Control //////////
	FLASH_ADV_n,
	FLASH_CE_n,
	FLASH_CLK,
	FLASH_RDY_BSY_n,
	FLASH_RESET_n,
	FLASH_WP_n,

	//////////// SSRAM Control //////////
	SSRAM_ADSC_n,
	SSRAM_ADSP_n,
	SSRAM_ADV_n,
	SSRAM_BE_n,
	SSRAM_CE1_n,
	SSRAM_CLK,

	//////////// MAX2 //////////
	MAX2_I2C_SCL,
	MAX2_I2C_SDA,

	//////////// DDR3 SODIMM //////////
	mem_a,
	mem_ba,
	mem_cas_n,
	mem_ck,
	mem_ck_n,
	mem_cke,
	mem_cs_n,
	mem_dm,
	mem_dq,
	mem_dqs,
	mem_dqs_n,
	mem_EVENT_n,
	mem_odt,
	mem_ras_n,
	mem_reset_n,
	mem_SCL,
	mem_SDA,
	mem_we_n,

	//////////// OCT RUP/RDN for Altera DDR3 UniPHY Controller //////////
	mem_oct_rdn,
	mem_oct_rup 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		OSC_50_BANK1;
input 		          		OSC_50_BANK3;
input 		          		OSC_50_BANK4;
input 		          		OSC_50_BANK7;
input 		          		OSC_50_BANK8;

//////////// Loop //////////
input 		          		LOOP_CLKIN0;
input 		          		LOOP_CLKIN1;
output		          		LOOP_CLKOUT0;
output		          		LOOP_CLKOUT1;

//////////// LED x 4 //////////
output		     [3:0]		LED;

//////////// BUTTON x 4 //////////
input 		     [3:0]		BUTTON;

//////////// SWITCH x 4 //////////
input 		     [3:0]		SW;

//////////// Temperature //////////
input 		          		TEMP_INT_n;
input 		          		TEMP_OVERT_n;
output		          		TEMP_SMCLK;
inout 		          		TEMP_SMDAT;

//////////// Fan //////////
output		          		FAN_CTRL;

//////////// PCIe0 4-Lane Downstream //////////
input 		          		PCIE0_PERST_n;
input 		          		PCIE0_REFCLK_p;
input 		     [3:0]		PCIE0_RX_p;
output		     [3:0]		PCIE0_TX_p;
output		          		PCIE0_WAKE_n;

//////////// Flash and SRAM Address/Data/OE/WM Share Bus //////////
output		    [25:1]		FSM_A;
inout 		    [31:0]		FSM_D;
output		          		FSM_OE_n;
output		          		FSM_WE_n;

//////////// Flash Control //////////
output		          		FLASH_ADV_n;
output		          		FLASH_CE_n;
output		          		FLASH_CLK;
input 		          		FLASH_RDY_BSY_n;
output		          		FLASH_RESET_n;
output		          		FLASH_WP_n;

//////////// SSRAM Control //////////
output		          		SSRAM_ADSC_n;
output		          		SSRAM_ADSP_n;
output		          		SSRAM_ADV_n;
output		     [3:0]		SSRAM_BE_n;
output		          		SSRAM_CE1_n;
output		          		SSRAM_CLK;

//////////// MAX2 //////////
output		          		MAX2_I2C_SCL;
inout 		          		MAX2_I2C_SDA;


//////////// DDR3 SODIMM //////////
output		    [15:0]		mem_a;
output		     [2:0]		mem_ba;
output		          		mem_cas_n;
output		     [1:0]		mem_ck;
output		     [0:0]		mem_ck_n;
output		     [0:0]		mem_cke;
output		     [1:0]		mem_cs_n;
output		     [7:0]		mem_dm;
inout 		    [63:0]		mem_dq;
inout 		     [7:0]		mem_dqs;
inout 		     [7:0]		mem_dqs_n;
input 		          		mem_EVENT_n;
output		     [1:0]		mem_odt;
output		          		mem_ras_n;
output		          		mem_reset_n;
output		          		mem_SCL;
inout 		          		mem_SDA;
output		          		mem_we_n;

//////////// OCT RUP/RDN for Altera DDR3 UniPHY Controller //////////
input 		          		mem_oct_rdn;
input 		          		mem_oct_rup;


//=======================================================
//  REG/WIRE declarations
//=======================================================
//=======================================================
//  External PLL Configuration ==========================
//=======================================================

//  Signal declarations
wire [ 3: 0] clk1_set_wr, clk2_set_wr, clk3_set_wr;
wire         rstn;
wire         conf_ready;
wire         counter_max;
wire  [7:0]  counter_inc;
reg   [7:0]  auto_set_counter;
reg          conf_wr;

//  Structural coding
assign clk1_set_wr = 4'd4; //100 MHZ
assign clk2_set_wr = 4'd4; //100 MHZ
assign clk3_set_wr = 4'd4; //100 MHZ

assign rstn = 1'b1;
assign counter_max = &auto_set_counter;
assign counter_inc = auto_set_counter + 1'b1;

always @(posedge OSC_50_BANK1 or negedge rstn)
	if(!rstn)
	begin
		auto_set_counter <= 0;
		conf_wr <= 0;
	end 
	else if (counter_max)
		conf_wr <= 1;
	else
		auto_set_counter <= counter_inc;


ext_pll_ctrl ext_pll_ctrl_Inst(
	.osc_50(OSC_50_BANK1), //50MHZ
	.rstn(rstn),

	// device 1 (HSMA_REFCLK)
	.clk1_set_wr(clk1_set_wr),
	.clk1_set_rd(),

	// device 2 (HSME_REFCLK)
	.clk2_set_wr(clk2_set_wr),
	.clk2_set_rd(),

	// device 3 (PGM_GXB_CLK)
	.clk3_set_wr(clk3_set_wr),
	.clk3_set_rd(),

	// setting trigger
	.conf_wr(conf_wr), // 1T 50MHz 
	.conf_rd(), // 1T 50MHz

	// status 
	.conf_ready(conf_ready),

	// 2-wire interface 
	.max_sclk(MAX2_I2C_SCL),
	.max_sdat(MAX2_I2C_SDA)

);

wire clk50;
wire clk_125m;
wire clk_100m;
wire pll_lock;
wire reset_n;
wire uniphy_ddr3_status_local_cal_success;
wire uniphy_ddr3_status_local_cal_fail;
wire uniphy_ddr3_status_local_init_done;

wire	[16 : 0]	reconfig_fromgxb;
wire	[3 : 0]	reconfig_togxb;
wire 				busy;

assign reset_n = 1'b1;
assign PCIE0_WAKE_n = 1'b1;
	


//=======================================================
//  Structural coding
//=======================================================

	
pll p0(
	.inclk0(OSC_50_BANK1),
	.c0(clk50),
	.c1(clk_125m),
	.c2(clk_100m),
	.locked(pll_lock)
);
	
altgx_reconfig p1 (
	.reconfig_clk (clk50),
	.reconfig_fromgxb (reconfig_fromgxb),
	.busy (busy),
	.reconfig_togxb (reconfig_togxb)
);

q_sys u0 (
        .clkin_100_clk                                     (clk_100m),                                   // clkin_50.clk
        .clkin_100_clk_in_reset_reset_n                    (reset_n),                    	 					// clkin_50_clk_in_reset.reset_n
        .pio_led_external_connection_export                (pio_led),                							// pio_led_external_connection.export
        .pio_key_external_connection_export                (pio_button),                 						// pio_key_external_connection.export
          
		  .pcie_hard_ip_0_refclk_export                      (PCIE0_REFCLK_p),                      			// pcie_hard_ip_0_refclk.export
        .pcie_hard_ip_0_pcie_rstn_export                   (PCIE0_PERST_n),                   				// pcie_hard_ip_0_pcie_rstn.export
		  .pcie_hard_ip_0_pipe_ext_powerdown_ext 				  (~PCIE0_PERST_n), 
		  .pcie_hard_ip_0_reconfig_busy_busy_altgxb_reconfig (busy), 													// pcie_hard_ip_0_reconfig_busy.busy_altgxb_reconfig
        .pcie_hard_ip_0_rx_in_rx_datain_0                  (PCIE0_RX_p[0]),                  				// pcie_hard_ip_0_rx_in.rx_datain_0
        .pcie_hard_ip_0_rx_in_rx_datain_1                  (PCIE0_RX_p[1]),                  				//                     .rx_datain_1
        .pcie_hard_ip_0_rx_in_rx_datain_2                  (PCIE0_RX_p[2]),                  				//                     .rx_datain_2
        .pcie_hard_ip_0_rx_in_rx_datain_3                  (PCIE0_RX_p[3]),                  				//                     .rx_datain_3
        .pcie_hard_ip_0_tx_out_tx_dataout_0                (PCIE0_TX_p[0]),                					// pcie_hard_ip_0_tx_out.tx_dataout_0
        .pcie_hard_ip_0_tx_out_tx_dataout_1                (PCIE0_TX_p[1]),                					//                      .tx_dataout_1
        .pcie_hard_ip_0_tx_out_tx_dataout_2                (PCIE0_TX_p[2]),                					//                      .tx_dataout_2
        .pcie_hard_ip_0_tx_out_tx_dataout_3                (PCIE0_TX_p[3]),                					//                      .tx_dataout_3
        .pcie_hard_ip_0_reconfig_togxb_data                (reconfig_togxb),                					// pcie_hard_ip_0_reconfig_togxb.data
        .pcie_hard_ip_0_reconfig_fromgxb_0_data            (reconfig_fromgxb),            					// pcie_hard_ip_0_reconfig_fromgxb_0.data
        .pcie_hard_ip_0_fixedclk_clk                       (clk_125m),                       				// pcie_hard_ip_0_fixedclk.clk		  

        .mem_if_ddr3_emif_0_pll_ref_clk_clk                (OSC_50_BANK8),                 					// mem_if_ddr3_emif_0_pll_ref_clk.clk		  
        .memory_mem_a                                      (mem_a),                                      // memory.mem_a
        .memory_mem_ba                                     (mem_ba),                                     //       .mem_ba
        .memory_mem_ck                                     (mem_ck),                                     //       .mem_ck
        .memory_mem_ck_n                                   (mem_ck_n),                                   //       .mem_ck_n
        .memory_mem_cke                                    (mem_cke),                                    //       .mem_cke
        .memory_mem_cs_n                                   (mem_cs_n),                                   //       .mem_cs_n
        .memory_mem_dm                                     (mem_dm),                                     //       .mem_dm
        .memory_mem_ras_n                                  (mem_ras_n),                                  //       .mem_ras_n
        .memory_mem_cas_n                                  (mem_cas_n),                                  //       .mem_cas_n
        .memory_mem_we_n                                   (mem_we_n),                                   //       .mem_we_n
        .memory_mem_reset_n                                (mem_reset_n),                                //       .mem_reset_n
        .memory_mem_dq                                     (mem_dq),                                     //       .mem_dq
        .memory_mem_dqs                                    (mem_dqs),                                    //       .mem_dqs
        .memory_mem_dqs_n                                  (mem_dqs_n),                                  //       .mem_dqs_n
        .memory_mem_odt                                    (mem_odt),                                    //       .mem_odt
        .oct_rdn                                           (mem_oct_rdn),                                // oct.rdn
        .oct_rup                                           (mem_oct_rup),                                //    .rup
        .mem_if_ddr3_emif_1_status_local_init_done         (uniphy_ddr3_status_local_init_done),         // mem_if_ddr3_emif_1_status.local_init_done
        .mem_if_ddr3_emif_1_status_local_cal_success       (uniphy_ddr3_status_local_cal_success),       //                          .local_cal_success
        .mem_if_ddr3_emif_1_status_local_cal_fail          (uniphy_ddr3_status_local_cal_fail)           //                          .local_cal_fail
		  		  
    );
	 
wire [3:0]	 pio_led;
wire [3:0]	 pio_button;
assign LED = ~pio_led; // led low-active
assign pio_button = ~BUTTON; // button low-active
assign FAN_CTRL = 1'b1;



endmodule
