
# (C) 2001-2016 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 16.0 211 win32 2016.07.26.17:13:55

# ----------------------------------------
# vcs - auto-generated simulation script

# ----------------------------------------
# This script provides commands to simulate the following IP detected in
# your Quartus project:
#     top
# 
# Altera recommends that you source this Quartus-generated IP simulation
# script from your own customized top-level script, and avoid editing this
# generated script.
# 
# To write a top-level shell script that compiles Altera simulation libraries
# and the Quartus-generated IP in your project, along with your design and
# testbench files, follow the guidelines below.
# 
# 1) Copy the shell script text from the TOP-LEVEL TEMPLATE section
# below into a new file, e.g. named "vcs_sim.sh".
# 
# 2) Copy the text from the DESIGN FILE LIST & OPTIONS TEMPLATE section into
# a separate file, e.g. named "filelist.f".
# 
# ----------------------------------------
# # TOP-LEVEL TEMPLATE - BEGIN
# #
# # TOP_LEVEL_NAME is used in the Quartus-generated IP simulation script to
# # set the top-level simulation or testbench module/entity name.
# #
# # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to
# # construct paths to the files required to simulate the IP in your Quartus
# # project. By default, the IP script assumes that you are launching the
# # simulator from the IP script location. If launching from another
# # location, set QSYS_SIMDIR to the output directory you specified when you
# # generated the IP script, relative to the directory from which you launch
# # the simulator.
# #
# # Source the Quartus-generated IP simulation script and do the following:
# # - Compile the Quartus EDA simulation library and IP simulation files.
# # - Specify TOP_LEVEL_NAME and QSYS_SIMDIR.
# # - Compile the design and top-level simulation module/entity using
# #   information specified in "filelist.f".
# # - Override the default USER_DEFINED_SIM_OPTIONS. For example, to run
# #   until $finish(), set to an empty string: USER_DEFINED_SIM_OPTIONS="".
# # - Run the simulation.
# #
# source <script generation output directory>/synopsys/vcs/vcs_setup.sh \
# TOP_LEVEL_NAME=<simulation top> \
# QSYS_SIMDIR=<script generation output directory> \
# USER_DEFINED_ELAB_OPTIONS="\"-f filelist.f\"" \
# USER_DEFINED_SIM_OPTIONS=<simulation options for your design>
# #
# # TOP-LEVEL TEMPLATE - END
# ----------------------------------------
# 
# ----------------------------------------
# # DESIGN FILE LIST & OPTIONS TEMPLATE - BEGIN
# #
# # Compile all design files and testbench files, including the top level.
# # (These are all the files required for simulation other than the files
# # compiled by the Quartus-generated IP simulation script)
# #
# +systemverilogext+.sv
# <design and testbench files, compile-time options, elaboration options>
# #
# # DESIGN FILE LIST & OPTIONS TEMPLATE - END
# ----------------------------------------
# 
# IP SIMULATION SCRIPT
# ----------------------------------------
# If top is one of several IP cores in your
# Quartus project, you can generate a simulation script
# suitable for inclusion in your top-level simulation
# script by running the following command line:
# 
# ip-setup-simulation --quartus-project=<quartus project>
# 
# ip-setup-simulation will discover the Altera IP
# within the Quartus project, and generate a unified
# script which supports all the Altera IP within the design.
# ----------------------------------------
# ACDS 16.0 211 win32 2016.07.26.17:13:55
# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="top"
QSYS_SIMDIR="./../../"
QUARTUS_INSTALL_DIR="D:/altera/16.0/quartus/"
SKIP_FILE_COPY=0
SKIP_ELAB=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS="+vcs+finish+100"
# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# initialize simulation properties - DO NOT MODIFY!
ELAB_OPTIONS=""
SIM_OPTIONS=""
if [[ `vcs -platform` != *"amd64"* ]]; then
  :
else
  :
fi

# ----------------------------------------
# copy RAM/ROM files to simulation directory
if [ $SKIP_FILE_COPY -eq 0 ]; then
  cp -f $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_AC_ROM.hex ./
  cp -f $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_inst_ROM.hex ./
  cp -f $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_sequencer_mem.hex ./
fi

vcs -lca -timescale=1ps/1ps -sverilog +verilog2001ext+.v -ntb_opts dtm $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v \
  $QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/stratixv_atoms_ncrypt.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/stratixv_atoms.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/stratixv_hssi_atoms_ncrypt.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/stratixv_hssi_atoms.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/synopsys/stratixv_pcie_hip_atoms_ncrypt.v \
  -v $QUARTUS_INSTALL_DIR/eda/sim_lib/stratixv_pcie_hip_atoms.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_005_error_adapter_0.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_004_error_adapter_0.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_001_error_adapter_0.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_error_adapter_0.sv \
  $QSYS_SIMDIR/submodules/alt_mem_ddrx_mm_st_converter.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_addr_cmd.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_addr_cmd_wrap.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ddr2_odt_gen.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ddr3_odt_gen.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_lpddr2_addr_cmd.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_odt_gen.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_rdwr_data_tmg.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_arbiter.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_burst_gen.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_cmd_gen.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_csr.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_buffer.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_buffer_manager.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_burst_tracking.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_dataid_manager.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_fifo.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_list.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_rdata_path.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_wdata_path.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_decoder.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_decoder_32_syn.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_decoder_64_syn.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_encoder.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_encoder_32_syn.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_encoder_64_syn.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_ecc_encoder_decoder_wrapper.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_axi_st_converter.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_input_if.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_rank_timer.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_sideband.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_tbp.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_timing_param.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_controller.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_ddrx_controller_st_top.v \
  \"+incdir+$QSYS_SIMDIR/submodules/\" $QSYS_SIMDIR/submodules/alt_mem_if_nextgen_ddr3_controller_core.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_dmaster_p2b_adapter.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_dmaster_b2p_adapter.sv \
  $QSYS_SIMDIR/submodules/altera_avalon_packets_to_master.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_packets_to_bytes.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_bytes_to_packets.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_dmaster_timing_adt.sv \
  $QSYS_SIMDIR/submodules/altera_avalon_st_jtag_interface.v \
  $QSYS_SIMDIR/submodules/altera_jtag_dc_streaming.v \
  $QSYS_SIMDIR/submodules/altera_jtag_sld_node.v \
  $QSYS_SIMDIR/submodules/altera_jtag_streaming.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_clock_crosser.v \
  $QSYS_SIMDIR/submodules/altera_std_synchronizer_nocut.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_idle_remover.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_idle_inserter.v \
  $QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_stage.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_rsp_mux.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_rsp_demux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_cmd_mux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_cmd_demux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_router_002.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2_router.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1_rsp_mux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1_cmd_mux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1_cmd_demux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1_router_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1_router.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_005.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_004.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter_001.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_avalon_st_adapter.v \
  $QSYS_SIMDIR/submodules/altera_avalon_dc_fifo.v \
  $QSYS_SIMDIR/submodules/altera_dcfifo_synchronizer_bundle.v \
  $QSYS_SIMDIR/submodules/altera_merlin_width_adapter.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_address_alignment.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_burst_uncompressor.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_mux_002.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_mux_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_mux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_demux_007.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_demux_005.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_demux_004.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_demux_003.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_rsp_demux_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_mux_007.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_mux_005.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_mux_004.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_mux_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_mux.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_demux_002.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_demux_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_cmd_demux.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_burst_adapter.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_burst_adapter_uncmpr.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_burst_adapter_13_1.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_burst_adapter_new.sv \
  $QSYS_SIMDIR/submodules/altera_incr_burst_converter.sv \
  $QSYS_SIMDIR/submodules/altera_wrap_burst_converter.sv \
  $QSYS_SIMDIR/submodules/altera_default_burst_converter.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_traffic_limiter.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_reorder_memory.sv \
  $QSYS_SIMDIR/submodules/altera_avalon_sc_fifo.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_010.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_008.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_007.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_004.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_003.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_002.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router_001.sv \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0_router.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_slave_agent.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_master_agent.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_slave_translator.sv \
  $QSYS_SIMDIR/submodules/altera_merlin_master_translator.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_mm_interconnect_0.v \
  $QSYS_SIMDIR/submodules/altera_mem_if_dll_stratixv.sv \
  $QSYS_SIMDIR/submodules/altera_mem_if_oct_stratixv.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_c0.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_dmaster.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0.v \
  $QSYS_SIMDIR/submodules/altera_avalon_mm_bridge.v \
  $QSYS_SIMDIR/submodules/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst.v \
  $QSYS_SIMDIR/submodules/altera_mem_if_sequencer_cpu_no_ifdef_params_sim_cpu_inst_test_bench.v \
  $QSYS_SIMDIR/submodules/altera_mem_if_sequencer_mem_no_ifdef_params.sv \
  $QSYS_SIMDIR/submodules/altera_mem_if_sequencer_rst.sv \
  $QSYS_SIMDIR/submodules/rw_manager_ac_ROM_no_ifdef_params.v \
  $QSYS_SIMDIR/submodules/rw_manager_ac_ROM_reg.v \
  $QSYS_SIMDIR/submodules/rw_manager_bitcheck.v \
  $QSYS_SIMDIR/submodules/rw_manager_core.sv \
  $QSYS_SIMDIR/submodules/rw_manager_datamux.v \
  $QSYS_SIMDIR/submodules/rw_manager_data_broadcast.v \
  $QSYS_SIMDIR/submodules/rw_manager_data_decoder.v \
  $QSYS_SIMDIR/submodules/rw_manager_ddr3.v \
  $QSYS_SIMDIR/submodules/rw_manager_di_buffer.v \
  $QSYS_SIMDIR/submodules/rw_manager_di_buffer_wrap.v \
  $QSYS_SIMDIR/submodules/rw_manager_dm_decoder.v \
  $QSYS_SIMDIR/submodules/rw_manager_generic.sv \
  $QSYS_SIMDIR/submodules/rw_manager_inst_ROM_no_ifdef_params.v \
  $QSYS_SIMDIR/submodules/rw_manager_inst_ROM_reg.v \
  $QSYS_SIMDIR/submodules/rw_manager_jumplogic.v \
  $QSYS_SIMDIR/submodules/rw_manager_lfsr12.v \
  $QSYS_SIMDIR/submodules/rw_manager_lfsr36.v \
  $QSYS_SIMDIR/submodules/rw_manager_lfsr72.v \
  $QSYS_SIMDIR/submodules/rw_manager_pattern_fifo.v \
  $QSYS_SIMDIR/submodules/rw_manager_ram.v \
  $QSYS_SIMDIR/submodules/rw_manager_ram_csr.v \
  $QSYS_SIMDIR/submodules/rw_manager_read_datapath.v \
  $QSYS_SIMDIR/submodules/rw_manager_write_decoder.v \
  $QSYS_SIMDIR/submodules/sequencer_data_mgr.sv \
  $QSYS_SIMDIR/submodules/sequencer_phy_mgr.sv \
  $QSYS_SIMDIR/submodules/sequencer_reg_file.sv \
  $QSYS_SIMDIR/submodules/sequencer_scc_acv_phase_decode.v \
  $QSYS_SIMDIR/submodules/sequencer_scc_acv_wrapper.sv \
  $QSYS_SIMDIR/submodules/sequencer_scc_mgr.sv \
  $QSYS_SIMDIR/submodules/sequencer_scc_reg_file.v \
  $QSYS_SIMDIR/submodules/sequencer_scc_siii_phase_decode.v \
  $QSYS_SIMDIR/submodules/sequencer_scc_siii_wrapper.sv \
  $QSYS_SIMDIR/submodules/sequencer_scc_sv_phase_decode.v \
  $QSYS_SIMDIR/submodules/sequencer_scc_sv_wrapper.sv \
  $QSYS_SIMDIR/submodules/sequencer_trk_mgr.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_irq_mapper.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_avalon_st_adapter.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_avalon_st_adapter_error_adapter_0.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_demux.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_demux_001.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_demux_003.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_demux_004.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_mux.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_mux_001.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_cmd_mux_002.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_001.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_002.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_003.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_004.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_005.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_006.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_007.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_008.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_router_009.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_rsp_demux.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_rsp_mux.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_rsp_mux_001.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_rsp_mux_003.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_s0_mm_interconnect_0_rsp_mux_004.sv \
  $QSYS_SIMDIR/submodules/afi_mux_ddr3_ddrx.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_clock_pair_generator.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_read_valid_selector.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_addr_cmd_datapath.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_reset.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_acv_ldc.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_memphy.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_reset_sync.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_new_io_pads.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_fr_cycle_shifter.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_fr_cycle_extender.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_read_datapath.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_write_datapath.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_core_shadow_registers.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_simple_ddio_out.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_phy_csr.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_iss_probe.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_addr_cmd_ldc_pads.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_addr_cmd_ldc_pad.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_addr_cmd_non_ldc_pad.v \
  $QSYS_SIMDIR/submodules/read_fifo_hard_abstract_ddrx_lpddrx.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_read_fifo_hard.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_p0_altdqdqs.v \
  $QSYS_SIMDIR/submodules/altdq_dqs2_stratixv.sv \
  $QSYS_SIMDIR/submodules/altdq_dqs2_abstract.sv \
  $QSYS_SIMDIR/submodules/altdq_dqs2_cal_delays.sv \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0_pll0.sv \
  $QSYS_SIMDIR/submodules/altera_reset_controller.v \
  $QSYS_SIMDIR/submodules/altera_reset_synchronizer.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_2.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_1.v \
  $QSYS_SIMDIR/submodules/top_mm_interconnect_0.v \
  $QSYS_SIMDIR/submodules/top_pio_led.v \
  $QSYS_SIMDIR/submodules/top_pio_button.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_h.sv \
  $QSYS_SIMDIR/submodules/altpcie_reconfig_driver.sv \
  $QSYS_SIMDIR/submodules/altpcieav_256_app.sv \
  $QSYS_SIMDIR/submodules/altpcieav_hip_interface.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_rxm.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_rd.sv \
  $QSYS_SIMDIR/submodules/altpcieav_sriov_vf_mux.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_wr.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_wr_2.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_wr_readmem_2.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_wr_wdalign_2.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_wr_tlpgen_2.sv \
  $QSYS_SIMDIR/submodules/altpcieav128_dma_wr.sv \
  $QSYS_SIMDIR/submodules/altpcieav128_dma_wr_readmem.sv \
  $QSYS_SIMDIR/submodules/altpcieav128_dma_wr_wdalign.sv \
  $QSYS_SIMDIR/submodules/altpcieav128_dma_wr_tlpgen.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_txs.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_arbiter.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_cra.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_hprxm_rdwr.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_hprxm_cpl.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_hprxm_txctrl.sv \
  $QSYS_SIMDIR/submodules/altpcieav_dma_hprxm.sv \
  $QSYS_SIMDIR/submodules/dma_controller.sv \
  $QSYS_SIMDIR/submodules/altpcie_dynamic_control.sv \
  $QSYS_SIMDIR/submodules/altpcie_fifo.v \
  $QSYS_SIMDIR/submodules/altpcie_256_hip_avmm_hwtcl.v \
  $QSYS_SIMDIR/submodules/altpcierd_hip_rs.v \
  $QSYS_SIMDIR/submodules/altpcie_sv_hip_ast_hwtcl.v \
  $QSYS_SIMDIR/submodules/altpcie_hip_256_pipen1b.v \
  $QSYS_SIMDIR/submodules/altpcie_rs_serdes.v \
  $QSYS_SIMDIR/submodules/altpcie_rs_hip.v \
  $QSYS_SIMDIR/submodules/altpcie_scfifo.v \
  $QSYS_SIMDIR/submodules/altpcie_sv_scfifo_ext.v \
  $QSYS_SIMDIR/submodules/altpcie_scfifo_sv.v \
  $QSYS_SIMDIR/submodules/altpcie_sv_gbfifo.v \
  $QSYS_SIMDIR/submodules/altpcie_tlp_inspector.v \
  $QSYS_SIMDIR/submodules/altpcie_tlp_inspector_trigger.v \
  $QSYS_SIMDIR/submodules/altpcie_hip_eq_dprio.v \
  $QSYS_SIMDIR/submodules/altpcie_hip_eq_bypass_ph3.v \
  $QSYS_SIMDIR/submodules/altpcietb_bfm_pipe_8to32.v \
  $QSYS_SIMDIR/submodules/altpcie_inspector.sv \
  $QSYS_SIMDIR/submodules/altpcie_monitor_sv_dlhip_sim.sv \
  $QSYS_SIMDIR/submodules/altpcie_tlp_inspector_monitor.sv \
  $QSYS_SIMDIR/submodules/altpcie_tlp_inspector_cseb.sv \
  $QSYS_SIMDIR/submodules/altera_xcvr_functions.sv \
  $QSYS_SIMDIR/submodules/sv_pcs.sv \
  $QSYS_SIMDIR/submodules/sv_pcs_ch.sv \
  $QSYS_SIMDIR/submodules/sv_pma.sv \
  $QSYS_SIMDIR/submodules/sv_reconfig_bundle_to_xcvr.sv \
  $QSYS_SIMDIR/submodules/sv_reconfig_bundle_to_ip.sv \
  $QSYS_SIMDIR/submodules/sv_reconfig_bundle_merger.sv \
  $QSYS_SIMDIR/submodules/sv_rx_pma.sv \
  $QSYS_SIMDIR/submodules/sv_tx_pma.sv \
  $QSYS_SIMDIR/submodules/sv_tx_pma_ch.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_h.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_avmm_csr.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_avmm_dcd.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_avmm.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_data_adapter.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_native.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_plls.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_resync.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_10g_rx_pcs_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_10g_tx_pcs_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_8g_rx_pcs_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_8g_tx_pcs_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_8g_pcs_aggregate_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_common_pcs_pma_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_common_pld_pcs_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_pipe_gen1_2_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_pipe_gen3_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_rx_pcs_pma_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_rx_pld_pcs_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_tx_pcs_pma_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/sv_hssi_tx_pld_pcs_interface_rbc.sv \
  $QSYS_SIMDIR/submodules/alt_reset_ctrl_lego.sv \
  $QSYS_SIMDIR/submodules/alt_reset_ctrl_tgx_cdrauto.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_csr_common_h.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_csr_common.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_csr_pcs8g_h.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_csr_pcs8g.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_csr_selector.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_mgmt2dec.sv \
  $QSYS_SIMDIR/submodules/altera_wait_generate.v \
  $QSYS_SIMDIR/submodules/sv_xcvr_emsip_adapter.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_pipe_native.sv \
  $QSYS_SIMDIR/submodules/top_onchip_memory2_0.v \
  $QSYS_SIMDIR/submodules/altera_avalon_mm_clock_crossing_bridge.v \
  $QSYS_SIMDIR/submodules/top_mem_if_ddr3_emif_0.v \
  $QSYS_SIMDIR/submodules/top_ddr3_status.v \
  $QSYS_SIMDIR/submodules/sv_xcvr_dfe_cal_sweep_h.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cal_seq.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_cif.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_uif.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_basic_acq.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_analog.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_analog_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_analog_datactrl.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_analog_rmw.sv \
  $QSYS_SIMDIR/submodules/alt_xreconf_analog_ctrlsm.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_offset_cancellation.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_offset_cancellation_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_eyemon.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_eyemon_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_eyemon_ctrl_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_eyemon_ber_sv.sv \
  $QSYS_SIMDIR/submodules/ber_reader_dcfifo.v \
  $QSYS_SIMDIR/submodules/step_to_mon_sv.sv \
  $QSYS_SIMDIR/submodules/mon_to_step_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_reg_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_cal_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_cal_sweep_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_cal_sweep_datapath_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_oc_cal_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_pi_phase_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_step_to_mon_en_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_adapt_tap_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_ctrl_mux_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_local_reset_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_cal_sim_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dfe_adapt_tap_sim_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_adce.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_adce_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_adce_datactrl_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_sv.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_cal.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_control.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_datapath.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_pll_reset.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_eye_width.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_align_clk.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_get_sum.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_dcd_cal_sim_model.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_mif.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_mif.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_mif_ctrl.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_mif_avmm.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_pll.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_pll.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_pll_ctrl.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_soc.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_ram.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_direct.sv \
  $QSYS_SIMDIR/submodules/sv_xrbasic_l2p_addr.sv \
  $QSYS_SIMDIR/submodules/sv_xrbasic_l2p_ch.sv \
  $QSYS_SIMDIR/submodules/sv_xrbasic_l2p_rom.sv \
  $QSYS_SIMDIR/submodules/sv_xrbasic_lif_csr.sv \
  $QSYS_SIMDIR/submodules/sv_xrbasic_lif.sv \
  $QSYS_SIMDIR/submodules/sv_xcvr_reconfig_basic.sv \
  $QSYS_SIMDIR/submodules/alt_arbiter_acq.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_basic.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_arbiter.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_m2s.sv \
  $QSYS_SIMDIR/submodules/sv_reconfig_bundle_to_basic.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_reconfig_cpu.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_reconfig_cpu_test_bench.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_irq_mapper.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_router.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_router_001.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_router_002.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_router_003.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_cmd_demux.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_cmd_demux_001.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_cmd_mux.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_cmd_mux_001.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_rsp_mux.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_rsp_mux_001.sv \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_avalon_st_adapter.v \
  $QSYS_SIMDIR/submodules/alt_xcvr_reconfig_cpu_mm_interconnect_0_avalon_st_adapter_error_adapter_0.sv \
  $QSYS_SIMDIR/top.v \
  -top $TOP_LEVEL_NAME
# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  ./simv $SIM_OPTIONS $USER_DEFINED_SIM_OPTIONS
fi
